Name:          uadk_engine
Summary:       UADK Accelerator Engine
Version:       1.0.0
Release:       9
License:       Apache-2.0
Source:        %{name}-%{version}.tar.gz
ExclusiveOS:   linux
BuildRoot:     %{_tmppath}/%{name}-%{version}-root
Prefix:        /usr/local/lib/engines-1.1
Conflicts:     %{name} < %{version}-%{release}
Provides:      %{name} = %{version}-%{release}
BuildRequires: libwd >= 2.3.21
BuildRequires: openssl-devel sed autoconf automake libtool
Requires:      openssl
ExclusiveArch: aarch64

Patch0001:     0001-digest-support-digest-multiple-update.patch
Patch0002:     0002-uadk_engine-define-the-variable-as-const.patch
Patch0003:     0003-ecc-fix-codecheck-warning.patch
Patch0004:     0004-rsa-delete-redundant-copy.patch
Patch0005:     0005-rsa-fix-coverity-warning.patch
Patch0006:     0006-ecc-cleanup-duplicate-public-key-allocation.patch
Patch0007:     0007-rsa-cleanup-about-reducing-function-parameters.patch
Patch0008:     0008-ecc-cleanup-sm2-compute-digest-function.patch
Patch0009:     0009-ecc-bugfix-about-ecc-init-after-alloc-sess.patch
Patch0010:     0010-rsa-cleanup-about-prime-generation.patch
Patch0011:     0011-ecc-cleanup-the-form-of-the-return-value.patch
Patch0012:     0012-engine-fix-uadk-engine-compatibility-issue.patch
Patch0013:     0013-digest-modify-the-process-of-free-session.patch
Patch0014:     0014-digest-modify-the-process-of-soft-and-hardware-hando.patch
Patch0015:     0015-ecc-bugfix-about-sm2-decryption.patch
Patch0016:     0016-dh-bugfix-about-dh-compute-key.patch
Patch0017:     0017-ecc-bugfix-about-ecc-general-init.patch
Patch0018:     0018-digest-fix-codecheck-warning.patch
Patch0019:     0019-cipher-fixup-a-code-check-warning.patch
Patch0020:     0020-rsa-fixup-a-code-check-warning.patch
Patch0021:     0021-cipher-delete-a-redundant-branch.patch
Patch0022:     0022-engine-fix-engine-can-t-work-under-hybrid-mode.patch
Patch0023:     0023-engine-add-the-kae-log-feature.patch
Patch0024:     0024-rsa-fix-interface-name.patch
Patch0025:     0025-ecc-cleanup-sm2-unreachable-code.patch
Patch0026:     0026-rsa-cleanup-of-code-style.patch
Patch0027:     0027-v1-fixup-about-uninitialized-variable.patch
Patch0028:     0028-ecc-fix-checking-conditions.patch
Patch0029:     0029-ecc-cleanup-print-log.patch
Patch0030:     0030-engine-fix-function-return-type.patch
Patch0031:     0031-rsa-fixup-about-the-wrong-copy.patch
Patch0032:     0032-README-modify-the-engine-id-name.patch
Patch0033:     0033-digest-improve-the-digest-performance.patch
Patch0034:     0034-cipher-support-the-sm4-ecb-alg.patch
Patch0035:     0035-cipher-fix-segmentation-fault-for-uadk_e_ctx_init.patch
Patch0036:     0036-cipher-sm4-ecb-algorithm-is-deleted-by-mistake.patch
Patch0037:     0037-rsa-bugfix-about-redundant-and-inefficient-operation.patch
Patch0038:     0038-uadk-engine-change-Copyright-to-2022.patch
Patch0039:     0039-README-move-test-script-to-sanity_test.sh.patch
Patch0040:     0040-uadk_engine-fix-string-compare-mode.patch
Patch0041:     0041-cipher-optimize-the-process-of-ctx-initialization.patch
Patch0042:     0042-cipher-adding-an-iv-update-to-a-decryption.patch
Patch0043:     0043-cipher-fix-cipher-decrypto-failed-as-use-jdk.patch
Patch0044:     0044-engine-add-receiving-timeout-count.patch
Patch0045:     0045-digest-fix-the-fault-as-using-the-nginx.patch
Patch0046:     0046-ecc-cleanup-of-static-code-check.patch
Patch0047:     0047-ecc-bugfix-about-return-value-check.patch
Patch0048:     0048-ecc-bugfix-multiple-definition-of-ecx-structure.patch
Patch0049:     0049-uadk_engine-remove-redundant-extern.patch
Patch0050:     0050-uadk_engine-add-timeout-protection-mechanism-in-poll.patch
Patch0051:     0051-rsa-cleanup-redundant-BN-operation.patch
Patch0052:     0052-rsa-bugfix-memory-leak-in-genkey-process.patch
Patch0053:     0053-rsa-remove-unused-software-method.patch
Patch0054:     0054-doc-Modify-maintainers.patch
Patch0055:     0055-rsa-modify-the-default-algorithm-of-keygen-soft-algo.patch
Patch0056:     0056-engine-initialize-resources-only-once.patch
Patch0057:     0057-engine-fix-function-type.patch
Patch0058:     0058-uadk_digest-fix-the-full-mac-buffer-length-as-doing-.patch
Patch0059:     0059-uadk_utils-fix-x86-local-build.patch
Patch0060:     0060-sm2-bugfix-about-segfault-in-sm2-ctrl-function.patch
Patch0061:     0061-uadk_engine-use-HW_V2-HW_V3-to-distinguish-different.patch
Patch0062:     0062-uadk-engine-update-the-numa-parameter-of-the-schedul.patch
Patch0063:     0063-uadk_engine-bugfix-side-effects-of-right-operand.patch
Patch0064:     0064-uadk_engine-cleanup-static-check-warning-of-clangtid.patch
Patch0065:     0065-uadk_engine-bugfix-enable-environment-variable.patch
Patch0066:     0066-uadk_engine-cleanup-magic-number-and-comments.patch
Patch0067:     0067-uadk_engine-cleanup-header-file.patch

%description
This package contains the UADK Accelerator Engine

%prep
%autosetup -n %{name} -p1

%build
autoreconf -i
chmod +x configure
./configure --enable-kae
make

%install
mkdir -p ${RPM_BUILD_ROOT}/usr/local/lib/engines-1.1
install -b -m755 src/.libs/uadk_engine.so.%{version} ${RPM_BUILD_ROOT}/usr/local/lib/engines-1.1

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(755,root,root)
/usr/local/lib/engines-1.1/uadk_engine.so.%{version}

%pre
if [ "$1" = "2" ] ; then  #2: update
    rm -rf $RPM_INSTALL_PREFIX/uadk_engine.so      > /dev/null 2>&1 || true
    rm -rf $RPM_INSTALL_PREFIX/uadk_engine.so.0    > /dev/null 2>&1 || true
fi

%post
if [[ "$1" = "1" || "$1" = "2" ]] ; then  #1: install 2: update
    ln -sf $RPM_INSTALL_PREFIX/uadk_engine.so.%{version}    $RPM_INSTALL_PREFIX/uadk_engine.so
    ln -sf $RPM_INSTALL_PREFIX/uadk_engine.so.%{version}    $RPM_INSTALL_PREFIX/uadk_engine.so.0
fi
/sbin/ldconfig

%preun
if [ "$1" = "0" ] ; then  #0: uninstall
    rm -rf $RPM_INSTALL_PREFIX/uadk_engine.so   > /dev/null 2>&1 || true
    rm -rf $RPM_INSTALL_PREFIX/uadk_engine.so.0 > /dev/null 2>&1 || true
    rm -f /var/log/uadk_engine.log              > /dev/null 2>&1 || true
    rm -f /var/log/uadk_engine.log.old          > /dev/null 2>&1 || true
fi

%postun
/sbin/ldconfig

%changelog
* Fri Dec 16 2022 JiangShui Yang <yangjiangshui@h-partners.com> 1.0.0-8
- Backport uadk engine patch for v1.0.1

* Thu Dec 08 2022 fushanqing <fushanqing@kylinos.cn> 1.0.0-8
- Enable debuginfo for fix strip

* Tue Jul 26 2022 Yang Shen <shenyang39@huawei.com> 1.0.0-7
- Backport uadk engine patch from v1.0.0 to v1.0.1

* Mon Mar 21 2022 linwenkai <linwenkai6@hisilicon.com> 1.0.0-6
- Backport uadk engine patch for v1.0.0

* Thu Mar 3 2022 linwenkai <linwenkai6@hisilicon.com> 1.0.0-5
- Backport uadk engine patch for v1.0.0

* Mon Feb 21 2022 linwenkai <linwenkai6@hisilicon.com> 1.0.0-4
- Backport uadk engine patch for v1.0.0

* Wed Jan 12 2022 linwenkai <linwenkai6@hisilicon.com> 1.0.0-3
- Backport uadk engine patch

* Fri Dec 10 2021 linwenkai <linwenkai6@hisilicon.com> 1.0.0-2
- Delete digest duplicate code

* Fri Dec 10 2021 linwenkai <linwenkai6@hisilicon.com> 1.0.0-1
- First Spec Version Include uadk_engine Code
